! A test program to verify that the software compiles, links, and runs.
!
Program test

Implicit None
Integer :: stat, unit, l
Real (Kind=8) :: l0, tt, te, ee
Real (Kind=8), Dimension(2500) :: clth, clte, clee
Character (80) :: ttFile, ttOffDiag, teFile, teOffDiag, bfFile
Data ttFile    /'tt_diag.dat'/
Data ttOffDiag /'tt_offdiag.dat'/
Data teFile    /'te_diag.dat'/
Data teOffDiag /'te_offdiag.dat'/
Data bfFile    /'testmodel.dat'/

Include 'compute_likelihood.fh'

clth = 0
clte = 0
clee = 0

unit = 8
OPEN( UNIT=unit, FILE=bfFile, STATUS='OLD', ACTION='READ', IOSTAT=stat)
If( stat .NE. 0 ) THEN
   Print *, 'Error opening :', bfFile
   Stop
Else
   Do
      READ( unit, *, IOSTAT=stat) l, tt, te, ee
      If( stat .NE. 0 ) THEN 
         EXIT
      Else
         clth(l) = tt
         clte(l) = te
         clee(l) = ee
!         print '(I8,3F13.4)', l, clth(l), clte(l), clee(l)
      EndIf
   EndDo
EndIf
if(maxval(clth(:)) .lt. 4500.) then 
print*,'likelihood approximation not valid'
stop
endif

Call common_all_likelihood(ttFile, ttOffDiag, teFile, teOffDiag, stat)
Print *, 'Read status: ', stat

Call compute_mapt_likelihood(clth, l0)
Print '("computed map tt ln(likelihood) : ", F15.10)', l0
Print '("correct  map tt ln(likelihood) : ", F15.10)', -486.2453756673d0

Call compute_mapte_likelihood(clth, clte, clee, l0)
Print '("computed map te ln(likelihood) : ", F15.10)', l0
Print '("correct  map te ln(likelihood) : ", F15.10)', -227.3852603143d0
Stop
End program test
